#ifndef SHORTSTR2_H
#define	SHORTSTR2_H
#include "Extension.h"
#include "mtl/SparseSet.h"
#include "mtl/SparseSetMultiLevel.h"
#include "solver/observers/ObserverDecision.h"
#include "../../solver/observers/ObserverDecision.h"
#include "../../mtl/SparseSetMultiLevel.h"

namespace Cosoco  {
    class ShortSTR2 : public Extension,ObserverDecision {
    protected :
        SparseSet Sval;
        SparseSet Ssup;
        SparseSetMultiLevel validTuples;
        vec<SparseSet*> gacIdValues;
        vec<int> lastSize;

        bool isValidTuple(vec<int> &tuple);
        void delTuple(int position,int lvl);

    public :
        // Constructors
        ShortSTR2(Problem &p,std::string n,vec<Variable*> &vars);
        ShortSTR2(Problem &p,std::string n,vec<Variable*> &vars,vec<vec<int> >&tuplesFromOtherConstraint);

        // filtering
        bool filter(Variable *x) override;
        //checking
        bool isSatisfiedBy(vec<int>& tuple) override;

        // Notifications : restore validTuples when backtrack is performed
        void notifyNewDecision(Variable *x,Solver &s) override;
        void notifyDeleteDecision(Variable *x,int v,Solver &s) override;

        virtual void delayedConstruction(int id) override;
        virtual void attachSolver(Solver *s) override;
        virtual bool isCorrectlyDefined() override;
    };
}

#endif	/* SHORTSTTR2_H */

