#ifndef COSOCO_MDD_H
#define COSOCO_MDD_H


#include <mtl/Vec.h>
#include <string>
#include <core/Variable.h>
#include "XCSP3Constraint.h"
#define falseNode nullptr

namespace Cosoco {
    class MDDNode {
    public :
        int id;
        int level;
        std::string name;
        vec<MDDNode*> childs;
        vec<int> directAccessToChilds;


        MDDNode(std::string n, int _id, int lvl, int maxNbChilds);
        int nbChilds();
        bool isRoot();
        void display();
        void addChild(int idv, MDDNode *target);
    };


    class MDD {
    protected :
        MDD() {}
    public :
        MDDNode *root;
        MDDNode *trueNode;
        int nbNodes;


        MDD(vec<XCSP3Core::XTransition*>  &transitions, vec<Variable*>& scope);
        virtual ~MDD();

        static MDD *buildFromAutomata(std::string name, vec<Variable *> &scope, string start, std::vector<string> &finals, vec<XCSP3Core::XTransition*> &transitions);
    };
}


#endif //COSOCO_MDD_H
