//
// Created by audemard on 10/12/2015.
//

#ifndef COSOCO_EXACTLYK_H
#define COSOCO_EXACTLYK_H

#include <constraints/globals/GlobalConstraint.h>

namespace Cosoco {

    class ExactlyK : public GlobalConstraint {
        int k;
        int value;
        bool done;

    public:
        ExactlyK(Problem &p, std::string n, vec<Variable *> &vars, int k, int val);

        // Filtering method, return false if a conflict occurs
        virtual bool filter(Variable *x) override ;

        // Checking
        virtual bool isSatisfiedBy(vec<int> &tuple) override ;

        virtual bool isCorrectlyDefined() override ;

        virtual State status() override;

        virtual void reinitialize() override ;


    };
}


#endif //COSOCO_EXACTLYK_H
