#ifndef SUMGE_H
#define	SUMGE_H

#include "Sum.h"
namespace Cosoco {

    class SumGE : public Sum , public ObjectiveConstraint{
    protected : 
        long min, max;
        int right, left;
        int leftmostPositiveCoefficientPosition;
        void computeBounds();
    public : 
        SumGE(Problem &p,std::string n,vec<Variable*> &vars,vec<int>&coefs,long l);
        virtual bool filter(Variable *x) override;
        
        
        // Checking
        virtual bool isSatisfiedBy(vec<int>& tuple) override;

        // Functions related to Objective constraint
        virtual void updateBound(long bound) override;           // Update the current bound
        virtual long maxUpperBound() override;                   // Bounds are included
        virtual long minLowerBound() override;                   // Bounds are included
        virtual long computeScore(vec<int> &solution) override;  // Compute the current score of the constraint
    };
}



#endif	/* SUMGE_H */

