#include <constraints/genericFiltering/TupleIteratorWithoutOrder.h>
#include "Intension.h"

using namespace Cosoco;


//----------------------------------------------------------
// check validity
//----------------------------------------------------------

bool Intension::isSatisfiedBy(vec<int> &t) {
    for(int i = 0; i < scope.size(); i++)
        tuple[scope[i]->_name] = t[i];
    return evaluator->evaluate(tuple);
}

//----------------------------------------------------------
// Filtering
//----------------------------------------------------------

bool Intension::filter(Variable *dummy) {
    for(Variable *x : scope) {
        if(x->size() > 1) return true;
        assert(x->size() == 1);
        tuple[x->_name] = x->value();
    }
    return evaluator->evaluate(tuple);
}

//----------------------------------------------------------
// Objective functions
//----------------------------------------------------------

// The constraint is something like : le(expr,bound) or ge(expr, bound)


void Intension::updateBound(long bound) {

    NodeBinary *nodeB = dynamic_cast<NodeBinary *>(evaluator->root);
    NodeConstant *nodeC = dynamic_cast<NodeConstant *>(nodeB->parameters[1]);
    nodeC->val = bound;
}


long Intension  ::maxUpperBound() {
    /*NodeBinary *nodeB = dynamic_cast<NodeBinary *>(evaluator->root);
    TupleIteratorWithoutOrder tupleIterator(scope);
    tupleIterator.setMinimalTuple();
    int max = INT_MIN;
    while(tupleIterator.hasNextTuple()) {
        vec<int> &tmp = *(tupleIterator.nextTuple());
        for(int i = 0; i < scope.size(); i++)
            scope[i]->valueForSupportCheck = tmp[i];
        int val = nodeB->parameter1->evaluate();
        if(val > max)
            max = val;
    }
    return max;*/
    return INT_MAX - 10;
}


long Intension::minLowerBound() {
    /*NodeBinary *nodeB = dynamic_cast<NodeBinary *>(evaluator->root);
    TupleIteratorWithoutOrder tupleIterator(scope);
    tupleIterator.setMinimalTuple();
    int min = INT_MAX;
    while(tupleIterator.hasNextTuple()) {
        vec<int> &tmp = *(tupleIterator.nextTuple());
        for(int i = 0; i < scope.size(); i++)
            scope[i]->valueForSupportCheck = tmp[i];
        int val = nodeB->parameter1->evaluate();
        if(val < min)
            min = val;
    }
    return min;*/
    return INT_MIN + 10;

}


long Intension::computeScore(vec<int> &solution) {
    assert(solution.size() == scope.size());
    for(int i = 0; i < scope.size(); i++)
        tuple[scope[i]->_name] = solution[i];
    NodeBinary *nodeB = dynamic_cast<NodeBinary *>(evaluator->root);
    return nodeB->parameters[0]->evaluate(tuple);
}
