#ifndef INTENSION_H
#define    INTENSION_H

#include "Constraint.h"
#include "XCSP3Tree.h"
using namespace XCSP3Core;
namespace Cosoco {
    class Intension : public Constraint, public ObjectiveConstraint {
    protected :
        Tree *evaluator;
        std::map<std::string, int> tuple;
    public :
        // Constructors
        Intension(Problem &p, std::string n, Tree *tree, vec<Variable*> &scope) : Constraint(p, n, scope), evaluator(tree) { type = "Intension"; }


        // filtering
        bool filter(Variable *x) override;

        //checking
        bool isSatisfiedBy(vec<int> &tuple) override;


        // Objective functions
        // The constraint is something like : le(expr,bound) or ge(expr,bound)
        // in NodeBinary: parameter1 is expr to optimize, parameter2 is current bound
        virtual void updateBound(long bound) override;

        virtual long maxUpperBound() override;

        virtual long minLowerBound() override;

        virtual long computeScore(vec<int> &solution) override;
    };
}


#endif	/* INTENSION_H */

