#ifndef DOMAINRANGE_H
#define DOMAINRANGE_H

#include "Domain.h"

namespace Cosoco {

    class DomainRange : public Domain {
    protected :
        int min, max;
    public:
        // Constructors
        DomainRange(int mn, int mx) : Domain(mx - mn + 1), min(mn), max(mx) {
            minval=min;
            maxval=max;
        }

        DomainRange(DomainRange &d) : Domain(d), min(d.min), max(d.max) {
            minval=min;
            maxval=max;
        }
        // Virtual Method conversion id to value

        inline int toIdv(int v) {
            if(v < min || v > max) return -1;
            return v - min;
        }

        inline int toVal(int idv) {
            assert(idv >= 0 && idv < sparseIdvs.maxSize());
            return min + idv;
        }
    };
};
#endif    
