#ifndef DOMAINVALUE_H
#define DOMAINVALUE_H

#include "mtl/Vec.h"
#include "Domain.h"
#include "mtl/SparseSetMultiLevel.h"

namespace Cosoco {
// TODO limit for toIdvs and to Val
    class DomainValue : public Domain {
    protected :
        vec<int> values;
        std::map<int, int> map;
    public:
        // Constructors
        DomainValue(const vec<int> &vals) : Domain(vals.size()) {
            minval = vals[0];
            maxval = vals[vals.size() - 1];

            for(int i = 0; i < vals.size(); i++) {
                values.push(vals[i]);
                map[vals[i]] = i; // [vals[i]] = i;
            }
        }


        DomainValue(DomainValue &d) : Domain(d) {
            assert(false);
            //d.map.copyTo(map);
            d.values.copyTo(values);
            minval = values[0];
            maxval = values[values.size() - 1];
        }


        // Virtual Method conversion id to value
        inline int toIdv(int v) { return map[v]; }


        inline int toVal(int idv) { return values[idv]; }

    };
};
#endif