#include "ForceIdv.h"
#include "solver/Solver.h"

using namespace Cosoco;

ForceIdvs::ForceIdvs(Solver &s,HeuristicVal *h, bool oo) : HeuristicVal(s),hv(h), conflictAlreadySeen(true), onlyOnce(oo) {
    s.addObserverConflict(this);
    idvs.growTo(solver.problem.nbVariables(),-1);
}

void ForceIdvs::notifyConflict(Constraint *c,int level) {
    if(onlyOnce == false) return;
    if(conflictAlreadySeen) return;
    idvs.fill(-1);
    conflictAlreadySeen = true;
}

int ForceIdvs::select(Variable *x) {
    if(x->size()==1) {
        return x->domain[0];
    }
    int lv = idvs[x->idx];
    if(lv!= -1 && x->domain.containsIdv(lv))
        return lv;
    return hv->select(x);
}

void ForceIdvs::setIdValues(vec<int> &v) {
    v.copyTo(idvs);
    conflictAlreadySeen = false;
}


