#ifndef COSOCO_FORCEVALUE_H
#define COSOCO_FORCEVALUE_H
#include "HeuristicVal.h"
#include <solver/observers/ObserverConflict.h>


namespace  Cosoco {
    // Try to assign value
    class ForceIdvs : public HeuristicVal, ObserverConflict{
    protected :
        vec<int> idvs;
        HeuristicVal *hv;
        bool conflictAlreadySeen;
        bool onlyOnce;
    public :
        ForceIdvs(Solver &s,HeuristicVal *h, bool oo = true);
        int select(Variable *x) override;

        void notifyConflict(Constraint *c,int level) override;
        void setIdValues(vec<int> &v);
    };
}


#endif //COSOCO_FORCEVALUE_H
