//
// Created by audemard on 25/09/2017.
//

#ifndef COSOCO_FORCEVARIABLES_H
#define COSOCO_FORCEVARIABLES_H

#include "HeuristicVar.h"

// This heuristic simulates the Large Neighboord Search technique.
// Useful only with optimization problems.

namespace Cosoco {
    class HeuristicVarLNS : public HeuristicVar {
    protected:
        vec<Variable*> variables;  // variables[0] must be assigned first.....
        vec<int> idvs;             // The indexes of the last solution
        HeuristicVar *hvar;        // The default heuristic
        int initialNbConflits;     // The fragment is started to solve
        bool _stop;                 // save the stop answer
    public:
        int maxConflicts;          // The maximum number of conflicts for exploration of the fragment.


        HeuristicVarLNS(Solver &s, HeuristicVar *h);
        Variable *select() override;
        bool stop() override;
        void setIdvs(vec<int> &ids);
        void createFragment(int nbVariables);
        bool fragmentIsUnsat();
        void addFragmentToNogoods();
    };

}



#endif //COSOCO_FORCEVARIABLES_H
