#include "LastConflictReasoning.h"

using namespace Cosoco;


LastConflictReasoning::LastConflictReasoning(Solver &s, HeuristicVar *hv) : HeuristicVar(s), hvar(hv), lc(nullptr) {
    s.addObserverConflict(this);
}


Variable *LastConflictReasoning::select() {
    if (lc != nullptr && solver.isAssigned(lc) == false)
        return lc;

    lc = nullptr;
    return hvar->select();
}


void LastConflictReasoning::notifyConflict(Constraint *c, int level) {
    if (solver.decisionLevel() == 0) return; //This is the end.
    lc = solver.decisionVariableAtLevel(level);
}





