//
// Created by audemard on 10/11/2015.
//

#ifndef COSOCO_UTILS_H
#define COSOCO_UTILS_H


template<class T>
const T &max(const T &a, const T &b) {
    return (a < b) ? b : a;     // or: return comp(a,b)?b:a; for version (2)
}


// Returns a random float 0 <= x < 1. Seed must never be 0.
static inline double drand(double &seed) {
    seed *= 1389796;
    int q = (int) (seed / 2147483647);
    seed -= (double) q * 2147483647;
    return seed / 2147483647;
}


// Returns a random integer 0 <= x < size. Seed must never be 0.
static inline int irand(double &seed, int size) {
    return (int) (drand(seed) * size);
}


#endif //COSOCO_UTILS_H
